<!--
  ~ Benchmarking Suite
  ~ Copyright 2014-2022 Engineering Ingegneria Informatica S.p.A.
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License");
  ~ you may not use this file except in compliance with the License.
  ~ You may obtain a copy of the License at
  ~
  ~ http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~ See the License for the specific language governing permissions and
  ~ limitations under the License.
  -->

<template>
  <v-container>

    <CommonHeader 
      title="All Providers"
      description="These are your own providers. Only you can run benchmarks on them with the credentials you set. Most metadata are visible to you only; however, other people might see the provider name if you decide to share some benchmarking metrics on them."
      >
      <v-btn small :disabled="!enabledActions.create" @click="$emit('newProvider')">New Provider</v-btn>
    </CommonHeader>

    <Filterbox
      :filteredSize="filteredItems.length"
      :itemsName="['provider', 'providers']"
      v-on:changed="filterkey=$event.key"
    />

    <v-list>
      <ProviderSummary
        :key="provider.id"
        v-for="(provider) in filteredItems"
        :item="provider"
        v-on:selected="$emit('viewProvider', $event)"
      />
    </v-list>

  </v-container>

</template>

<script>

import CommonHeader from '../common/CommonHeader.vue';
import Filterbox from '../common/Filterbox.vue';
import ProviderSummary from './ProviderSummary.vue';

import { getProviderSharingLevel } from '../common/benchsuite.js';


export default {

  name: 'ProvidersList',

 components: {
    CommonHeader,
    ProviderSummary,
    Filterbox
  },
  
  data: () => ({
    providers: [],
    filterkey: "",
    enabledActions: {
      create:false
    }
  }),

  mounted () {
    this.$store.commit('fbkon')
    this.$http
      .get(this.$REST_BASE_URL + '/providers')
      .then(response => (this.providers = response.data))
      .finally(() => {this.$store.commit('fbkoff')});

    // update actions
    this.$http
          .get(this.$REST_BASE_URL + '/providers/user_actions')
      .then(response => {
        this.enabledActions.create = response.data.create=="True";
      })

    this.$emit("title", "Providers");

  },
  
  methods: {
  },
  
  computed: {
    filteredItems() {
      return this.providers.filter(item => {
        if(!this.filterkey)
          return true;
        var text = "";
        for(var k in item) {
          text += " " + item[k];
        }
        text += " " + getProviderSharingLevel(item);
        return text.toLowerCase().includes(this.filterkey.toLowerCase());
      }).sort((a,b) => {return (b.name+b.id) < (a.name+a.id) ? 1 : -1});
    }
    
  }
  

};

</script>

<style>
div.provider-name {
  font-weight:bold;
}
</style>


